from http import HTTPStatus
from typing import Any
from urllib.parse import quote

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.cws_error_dto import CwsErrorDTO
from ...models.tracking import Tracking
from ...types import Response


def _get_kwargs(
    barcode: str,
    *,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> dict[str, Any]:
    headers: dict[str, Any] = {}
    headers["Authorization"] = authorization

    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": "/dpi/tracking/v1/trackings/{barcode}".format(
            barcode=quote(str(barcode), safe=""),
        ),
    }

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> CwsErrorDTO | Tracking | None:
    if response.status_code == 200:
        response_200 = Tracking.from_dict(response.json())

        return response_200

    if response.status_code == 404:
        response_404 = CwsErrorDTO.from_dict(response.json())

        return response_404

    if response.status_code == 500:
        response_500 = CwsErrorDTO.from_dict(response.json())

        return response_500

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> Response[CwsErrorDTO | Tracking]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    barcode: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[CwsErrorDTO | Tracking]:
    """Get Trackings V1

     Get all tracking information of for the item (identified by the given barcode).

    Args:
        barcode (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[CwsErrorDTO | Tracking]
    """

    kwargs = _get_kwargs(
        barcode=barcode,
        authorization=authorization,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    barcode: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> CwsErrorDTO | Tracking | None:
    """Get Trackings V1

     Get all tracking information of for the item (identified by the given barcode).

    Args:
        barcode (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        CwsErrorDTO | Tracking
    """

    return sync_detailed(
        barcode=barcode,
        client=client,
        authorization=authorization,
    ).parsed


async def asyncio_detailed(
    barcode: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[CwsErrorDTO | Tracking]:
    """Get Trackings V1

     Get all tracking information of for the item (identified by the given barcode).

    Args:
        barcode (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[CwsErrorDTO | Tracking]
    """

    kwargs = _get_kwargs(
        barcode=barcode,
        authorization=authorization,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    barcode: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> CwsErrorDTO | Tracking | None:
    """Get Trackings V1

     Get all tracking information of for the item (identified by the given barcode).

    Args:
        barcode (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        CwsErrorDTO | Tracking
    """

    return (
        await asyncio_detailed(
            barcode=barcode,
            client=client,
            authorization=authorization,
        )
    ).parsed
